/********************************************************************************
* Copyright (c) 2004, The Hong Kong University of Science and Technology (HKUST)
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
*
*   * Redistributions of source code must retain the above copyright notice,
*     this list of conditions,the authors and the following disclaimer.
*   * Redistributions in binary form must reproduce the above copyright notice,
*     this list of conditions,the authors and the following disclaimer in
*     the documentation and/or other materials provided with the distribution.
*   * Neither the name of the university nor the names of its
*     contributors may be used to endorse or promote products derived from
*     this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
* ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
* LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
* POSSIBILITY OF SUCH DAMAGE.
* Author: Hejun Wu (vmnet@ust.hk).
********************************************************************************/

// DeployerView.cpp : implementation of the CDeployerView class
//

#include "stdafx.h"
#include "Deployer.h"

#include "DeployerDoc.h"
#include "DeployerView.h"
#include <io.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();
	char strText[20];
	
// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CEdit	m_edit;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	afx_msg void OnChangeEdit1();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_EDIT1, m_edit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_EN_CHANGE(IDC_EDIT1, OnChangeEdit1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
extern unsigned short int g_numNodes;
void CDeployerApp::OnAppAbout()
{

}

/////////////////////////////////////////////////////////////////////////////
// CDeployerApp message handlers


	
CDeployerModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
END_OBJECT_MAP()

LONG CDeployerModule::Unlock()
{
	AfxOleUnlockApp();
	return 0;
}

LONG CDeployerModule::Lock()
{
	AfxOleLockApp();
	return 1;
}
LPCTSTR CDeployerModule::FindOneOf(LPCTSTR p1, LPCTSTR p2)
{
	while (*p1 != NULL)
	{
		LPCTSTR p = p2;
		while (*p != NULL)
		{
			if (*p1 == *p)
				return CharNext(p1);
			p = CharNext(p);
		}
		p1++;
	}
	return NULL;
}


int CDeployerApp::ExitInstance()
{
	if (m_bATLInited)
	{
		_Module.RevokeClassObjects();
		_Module.Term();
		CoUninitialize();
	}

	return CWinApp::ExitInstance();

}

BOOL CDeployerApp::InitATL()
{
	m_bATLInited = TRUE;

#if _WIN32_WINNT >= 0x0400
	HRESULT hRes = CoInitializeEx(NULL, COINIT_MULTITHREADED);
#else
	HRESULT hRes = CoInitialize(NULL);
#endif

	if (FAILED(hRes))
	{
		m_bATLInited = FALSE;
		return FALSE;
	}

	_Module.Init(ObjectMap, AfxGetInstanceHandle());
	_Module.dwThreadID = GetCurrentThreadId();

	LPTSTR lpCmdLine = GetCommandLine(); //this line necessary for _ATL_MIN_CRT
	TCHAR szTokens[] = _T("-/");

	BOOL bRun = TRUE;
	LPCTSTR lpszToken = _Module.FindOneOf(lpCmdLine, szTokens);
	while (lpszToken != NULL)
	{
		if (lstrcmpi(lpszToken, _T("UnregServer"))==0)
		{
			_Module.UpdateRegistryFromResource(IDR_DEPLOYER, FALSE);
			_Module.UnregisterServer(TRUE); //TRUE means typelib is unreg'd
			bRun = FALSE;
			break;
		}
		if (lstrcmpi(lpszToken, _T("RegServer"))==0)
		{
			_Module.UpdateRegistryFromResource(IDR_DEPLOYER, TRUE);
			_Module.RegisterServer(TRUE);
			bRun = FALSE;
			break;
		}
		lpszToken = _Module.FindOneOf(lpszToken, szTokens);
	}

	if (!bRun)
	{
		m_bATLInited = FALSE;
		_Module.Term();
		CoUninitialize();
		return FALSE;
	}

	hRes = _Module.RegisterClassObjects(CLSCTX_LOCAL_SERVER, 
		REGCLS_MULTIPLEUSE);
	if (FAILED(hRes))
	{
		m_bATLInited = FALSE;
		CoUninitialize();
		return FALSE;
	}	

	return TRUE;

}

void CAboutDlg::OnChangeEdit1() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed nto the mask.
	
	// TODO: Add your control notification handler code here
	m_edit.GetWindowText(strText,20);
}

/////////////////////////////////////////////////////////////////////////////
// CDeployerView

IMPLEMENT_DYNCREATE(CDeployerView, CView)

BEGIN_MESSAGE_MAP(CDeployerView, CView)
	//{{AFX_MSG_MAP(CDeployerView)
	ON_COMMAND(ID_BUTTON32771, OnDeploy)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDeployerView construction/destruction

CDeployerView::CDeployerView()
{
	// TODO: add construction code here
	char header[]={"<?xml version=\"1.0\" encoding=\"utf-8\" ?> \n <motelist seed=\"432423\" \n title=\"Minimal example of run file operation\" \n xmlns=\"http://www.cshcn.umd.edu/research/atemu/\">\n"};
	nodeCounts=0;
	configFh=_open("sample.xrun",_O_RDWR| _O_CREAT|_O_BINARY|_O_TRUNC, _S_IREAD| _S_IWRITE );  
	if(configFh!=-1)
	{
//	configLen=_filelength(configFh);
	//pConfigBuffer=new char[500];
	_write(configFh,header,strlen(header));
//	_read(configFh,pConfigBuffer,configLen);
	pNodeBuffer = new char[1000];
	}
	else
		exit(1);

}

CDeployerView::~CDeployerView()
{
}

BOOL CDeployerView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CDeployerView drawing

void CDeployerView::OnDraw(CDC* pDC)
{
	CDeployerDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CDeployerView printing

BOOL CDeployerView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CDeployerView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CDeployerView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CDeployerView diagnostics

#ifdef _DEBUG
void CDeployerView::AssertValid() const
{
	CView::AssertValid();
}

void CDeployerView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDeployerDoc* CDeployerView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDeployerDoc)));
	return (CDeployerDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDeployerView message handlers
void CDeployerView::writeBackPosition(char* pCoorinates,int length)
{
	nodeCounts++;	
	sprintf(pNodeBuffer,"\t<mote id=\"%d\" model=\"mica2\" state=\"on\">\n\t\t<param name=\"position\" value=\"%s\" />\n\t\t<flash href=\"run/main.exe\" />\n\t</mote>\n",
		nodeCounts,pCoorinates);
	_write(configFh,pNodeBuffer,strlen(pNodeBuffer));
	
}


unsigned short int g_numNodes = 0;
#define MAX_NUM_NODES  100
void CDeployerView::OnDeploy() 
{
	// TODO: Add your command handler code here
	unsigned short int area[MAX_NUM_NODES][MAX_NUM_NODES];
	int i,j,k;
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
	g_numNodes = atoi(aboutDlg.strText);
	for(i=0;i<MAX_NUM_NODES;i++)
		for(j=0;j<MAX_NUM_NODES;j++)
			area[i][j]=0;
		area[0][0]=1;
	if(g_numNodes<=0||g_numNodes>MAX_NUM_NODES)
		g_numNodes = MAX_NUM_NODES;
	k=0;
	int nFh;
	char tempName[100];
    nFh = _open("position.txt",_O_RDWR| _O_CREAT|_O_BINARY|_O_TRUNC, _S_IREAD| _S_IWRITE );  
	g_numNodes--;
	sprintf(tempName,"%d,%d,0",0,0);									
	writeBackPosition(tempName,0);
	sprintf(tempName,"%d,%d,0\n",0,0);									
	_write(nFh,tempName,strlen(tempName));
	float para=(float)(1.00001);
	int temp =(int)((float)g_numNodes*para);
	while(k<g_numNodes)
	{
		for(i=1;i<temp;i++)
			for(j=1;j<temp;j++)
			{
				int x, y;
				int r=::rand();
				if(r/30000>=1)
				{
					int m = ::rand();
					x=(r+m)%(::rand()%(temp+1)+1);
					y=m%j;
					area[x][y]=1;
					k++;
					sprintf(tempName,"%d,%d,0",x,y);									
					writeBackPosition(tempName,0);
					strcat(tempName,"\n");
					_write(nFh,tempName,strlen(tempName));
					if(k==g_numNodes)
					{
						sprintf(tempName,"</motelist>");
						_write(configFh,tempName,strlen(tempName));
						close(configFh);
						close(nFh);
						return;
					}
				}
			}
	}
}
